require 'socket'

class HelperAppUnixServerSocket
  def initialize( path )
    @sock = UNIXSocket.new( path )
  end
  
  def close
    @sock.close
  end
  
  def read
    msg_len_str = read_bytes( 4 );
    
    if ( !msg_len_str )
      return nil
    end
    
    msg_len = msg_len_str.unpack( 'N' )[0]
    msg     = read_bytes( msg_len )
    
    return msg
  end
  
  def write( msg )
    msg_len = msg.length
    
    write_bytes( [msg_len].pack( 'N' ) )
    write_bytes( msg )
  end
  
  def read_bytes( num_bytes )
    amt_in  = 0
	data_in = ''
    
    while ( amt_in < num_bytes )
      one_in = @sock.recv( num_bytes - amt_in )
      
      if ( !one_in )
        return nil
      end
      
      data_in += one_in
      amt_in  += one_in.length  
    end
    
    return data_in
  end
  
  def write_bytes( bytes )
    len     = bytes.length
    amt_out = 0
    
    while ( amt_out < len )
      one_out = @sock.send( bytes.slice( amt_out..-1 ), 0 )
      
      if ( !one_out )
        return false
      end
      
      amt_out += one_out
    end
    
    return true
  end
end
